{% extends "crud.html" %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block datatable_filters %}
    <div class="col-12 offset-md-5 col-md-3">
        <div class="form-group">
            <select class="form-control" data-datatable-filter="2">
                <option value="">All Categories</option>
                {% for option in categories %}
                    <option value="{{ option.decode("utf-8") }}">{{ option.decode("utf-8")|normalize|title }}</option>
                {% endfor %}
            </select>
        </div>
    </div>
{% endblock %}


{% block add_form %}
    <div class="row">
        <div class="col-12 col-md-6">
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "item_code"|normalize|title }}*</label>
                        <input type="text" name="item_code" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "description"|normalize|title }}*</label>
                        <textarea name="description" class="form-control" rows="4" required></textarea>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-12 col-md-6">
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "category"|normalize|title }}*</label>
                        <select name="category" class="form-control" required>
                            <option value="">-- Select Category --</option>
                            {% for option in categories %}
                                <option value="{{ option.decode("utf-8") }}">{{ option.decode("utf-8")|normalize|title }}</option>
                            {% endfor %}
                        </select>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "default_unit"|normalize|title }}*</label>
                        <select name="default_unit" class="form-control" required>
                            <option value="">-- Select Default Unit --</option>
                            {% for option in units %}
                                <option value="{{ option.decode("utf-8") }}">{{ option.decode("utf-8") }}</option>
                            {% endfor %}
                        </select>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block empty_spiel %}
    Add Raw Materials, these may include
    <br />
    product components, and packaging
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'item_code',
        searchable: true,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                return '<a href="javascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> {0}</a>'.format(data);
            }
        }
    },
    {
        data: 'description',
        searchable: true,
        orderable: true
    },
    {
        data: 'category',
        className: 'd-none d-sm-table-cell',
        searchable: false,
        orderable: true,
        render: function(data) {
            return data.normalize().titleCase();
        }
    },
    {
        data: 'stock_on_hand',
        className: 'd-none d-sm-none d-md-table-cell',
        searchable: false,
        orderable: true
    },
    {
        data: 'last_transaction',
        searchable: false,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                if (data.record !== null) {
                    return moment(data.record.date_created);
                } else {
                    return moment('1970-01-01 00:00:00');
                }
            } else {
                return data.spiel;
            }
        }
    },
    {
        data: '_id',
        searchable: false,
        orderable: false,
        className: 'text-center',
        render: function(data) {
            return '<a href="{0}" class="btn btn-success btn-sm btn-block"><i class="fa fa-list fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Stock Card</span></a>'.format('{{ url_for(".stock_card", _id="placeholder", from="records") }}'.replace('placeholder', data));
        }
    },
    {
        data: '_id',
        searchable: false,
        orderable: false,
        className: 'text-center',
        render: function(data) {
            {% if session.user.access_levels.permissions.get(request.mod, {}).get('delete', False) %}
            return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Delete</span></a>'.format(data);
            {% else %}
            return '';
            {% endif %}
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    $dom.document.on('change', 'select[name="category"]', function(e) {
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        let val = $(this).val();
        if (val == 'raw material') {
            $('[data-crud="{0}"] select[name="default_unit"]'.format(crud)).val('kg').trigger('change');
        } else if (val == 'packaging material') {
            $('[data-crud="{0}"] select[name="default_unit"]'.format(crud)).val('pc').trigger('change');
        } else {
            $('[data-crud="{0}"] select[name="default_unit"]'.format(crud)).val('').trigger('change');
        }
    });
{# </script> #}
{% endblock %}
